/*
Copyright 2004 Cesar Tardaguila & Javier Tardaguila

This file is part of Drops.

Drops is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Srops is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Drops; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import Code.UI.*
import Code.World.*


class Code.World.DropsController
{
	private var tl				: MovieClip;
	
	private var theView			: DropsView;
	private var theWorld		: DropsWorld;
	
	private var gameTimeline	: MovieClip;
	
	function DropsController( line: MovieClip, view: DropsView )
	{
		this.tl = line;
		this.theView = view;
	}
	
	public function init(  )
	{
		this.theView.controller = this;
		
		this.initWorld( );
	}
	
	private function initWorld( )
	{
		this.gameTimeline = this.tl.createEmptyMovieClip( "gameTimeline", this.tl.getNextHighestDepth( ) );
	
		this.theWorld = new DropsWorld( this.gameTimeline );
		
		this.theWorld.registerEvent( this, "onStartGame" );
		this.theWorld.registerEvent( this, "onTimeChange" );
		this.theWorld.registerEvent( this, "onEndOfTime" );
		this.theWorld.registerEvent( this, "onEndOfGame" );

		this.theWorld.initWorld( { baseline: this.tl } );
	}
	
	private function stopWorld( )
	{
		//this.theWorld.stopWorld( );
	}	
	
	private function onTimeChange( param: Object )
	{
		this.theView.timeHasChanged( param );
	}
	
	private function onStartGame( param: Object )
	{
		this.theView.firstFeedback( param );
	}
	
	private function onEndOfTime( param: Object )
	{
		this.theView.timeIsOver( param );
	}
	
	private function onEndOfGame( param: Object )
	{
		this.theView.endOfGame( param );
	}
	
	
	public function runGame( )
	{
		this.theWorld.gameCanRun( );	
	}
	
	public function newGame( )
	{
		this.theWorld.newGame( );	
	}
	
	public function endGame( )
	{
		this.theWorld.endGame( );
	}
}