import net.designnation.behaviours.*
import net.designnation.data.*

class net.designnation.behaviours.SMachine 
{
	private static var SMS_STARTED: Number= 0;
	private static var SMS_STOPPED: Number= 1;	
	
	private static var MACHINE_TAG: String		= "sMachine";
	
	private var smachineState: Number= SMS_STOPPED;	
	private var currStateVal: State= undefined;
	private var initStateVal: State= undefined;
	private var reentryState: Boolean= false;
	
	private var transitionsMap: HashMap;
	private var statesMap	  : HashMap;
	
	public var __traceInfo__: Boolean= false;
	
	public function SMachine(  )
	{				
	}
	
	public function resetToInit( initState: State )
	{
		this.currStateVal	= initState;
		this.initStateVal= initState;
	}
	
	public function executeCycle( parameter: Object ): Number
	{
		if( this.smachineState== SMS_STARTED )
		{
			if( this.currStateVal!= undefined )
			{
				var arg: Object;
				if( !this.reentryState )
				{
					arg= this.currStateVal.execute( this.currStateVal );
				}
								
				var pairRes: Pair				 	= this.currStateVal.evalState( arg );
				var currStateAux: State		 		= State( pairRes.first );
				var usedTransition: Transition 		= Transition( pairRes.second );
				
				if( !( this.reentryState= ( currStateAux== undefined ) ) )
				{
					this.currStateVal= currStateAux;
					this.currStateVal.__traceInfo__= this.__traceInfo__;
				
					usedTransition.__traceInfo__= this.__traceInfo__;
						
					usedTransition.execute( usedTransition );
				}				
			}
		}
		return this.smachineState;
	}
	
	public function startMachine(  )
	{
		this.smachineState= SMS_STARTED;
	}
	
	public function stopMachine(  )
	{
		this.smachineState= SMS_STOPPED;
	}
	
	public function get SMachineState(  )
	{
		return this.smachineState;
	}
	
	public function get initialState(  )
	{
		return this.initStateVal;
	}
	
	public function get currentState(  )
	{
		return this.currStateVal;
	}
	
	private function resolveRefs( transitionsRef: HashMap, statesRef: HashMap )
	{						
		var itState: IIterator= statesRef.iterator(  );

		// Desreferenciacion de transiciones de estado
		//
		while( itState.hasNext(  ) )
		{
			var pairAux: Pair= Pair( itState.next(  ) );
			
			var currRef: State= State( pairAux.second );
	
			// Returns Array
			var transArr: Object= statesRef.getItem( pairAux.first ); 
			
			var currState: State= State( this.statesMap.getItem( pairAux.first ) );
			
			for( var ix: Number= 0; ix< transArr.length; ix++ )
			{								
				currState.addTransition( Transition( this.transitionsMap.getItem( transArr[ ix ] ) ) );
			}						
		}
		var itTransition: IIterator= transitionsRef.iterator(  );
		// Desreferenciacion de estados de transicion
		while( itTransition.hasNext(  ) )
		{
			var pair: Pair= Pair( itTransition.next(  ) );
			
			var currTranRef: Transition= Transition( pair.second );
			
			var currTran: Transition= Transition( this.transitionsMap.getItem( pair.first ) );

			currTran.initState= State( this.statesMap.getItem( pair.second.first ) );
			
			currTran.endState= State( this.statesMap.getItem( pair.second.second ) );
		}
		this.transitionsMap = null;
		this.statesMap		= null;
	}
}