import net.designnation.behaviours.*
import net.designnation.data.*

class net.designnation.behaviours.Transition
{
	public static var TRANSITION_TAG: String= "transition";	
	public static var INIT_STATE_TAG: String= "initState";
	public static var END_STATE_TAG	: String= "endState";
	public static var EVAL_TAG		: String= "eval";
	public static var ACTION_TAG	: String= "action";

	private var initStateVal: State= undefined;
	private var endStateVal: State= undefined;
	private var evaluationCallbackVal: CallbackDecl;
	private var actionCallbackVal: CallbackDecl;
	private var idVal: String;
	private var referencesMap: HashMap;
	
	public var __traceInfo__: Boolean= false;
		
	public function Transition( idParam: String, initSt: State, endSt: State, 
		evalCallbackParam: CallbackDecl, actionCallbackParam: CallbackDecl )
	{
		this.id= idParam;
		
		this.initState			  	= initSt;
		this.endState 			  	= endSt;
		this.evaluationCallbackVal	= evalCallbackParam;
		this.actionCallbackVal		= actionCallbackParam;
	}
	
	public function set id( idParam: String )
	{
		this.idVal= idParam;
	}
		
	public function get id(  ): String
	{
		return this.idVal;
	}
	
	public function set initState( state: State )
	{
		state.addTransition( this );
		
		this.initStateVal= state;
	}
	
	public function set endState( state: State )
	{
		this.endStateVal= state;
	}
	
	public function get initState(  ): State
	{
		return this.initStateVal;
	}
	
	public function get endState(  ): State
	{
		return this.endStateVal;
	}
	
	public function set evaluationCallback( obj: CallbackDecl )
	{
		this.evaluationCallbackVal= obj;
	}
	
	public function set actionCallback( obj: CallbackDecl )
	{
		this.actionCallbackVal= obj;
	}
	
	public function execute( parameter: Object ): Object
	{
		if( this.__traceInfo__ )
		{
			trace( "T[A]:"+ this.id+"; "+ this.actionCallbackVal.callbackMethod );
		}
		return this.actionCallbackVal.fire( parameter );			
	}
	
	public function evaluate(  ): Boolean
	{
		var retVal: Boolean= true;
		
		if( this.evaluationCallbackVal!= undefined )
		{
		 	retVal= Boolean( evaluationCallbackVal.fire( this ) );		 			 
		}
		return retVal;
	}

	public function toString( ): String
	{
		var str = "Transition :[\n";
		str+= "id " + this.id+ "\n";
		str+= "initState " + this.initState + "\n";
		str+= "endState " + this.endState+ "\n";
		str+="]";
		return str;
	}
}	